'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _getVariableDeclarator = require('./getVariableDeclarator');

var _getVariableDeclarator2 = _interopRequireDefault(_getVariableDeclarator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var getPositionIdentifier = function getPositionIdentifier(_ref) {
  var node = _ref.node;
  return _lodash2.default.get(node, 'id.name', node.start + ':' + node.end);
};

var getFunctionIdentifier = function getFunctionIdentifier(path) {
  if (t.isFunctionDeclaration(path)) return getPositionIdentifier(path);
  if (t.isArrowFunctionExpression(path) || t.isFunctionExpression(path)) {
    return getPositionIdentifier((0, _getVariableDeclarator2.default)(path));
  }

  throw path.buildCodeFrameError('`path` is unsupported Function definition');
};

var getEntryIdentifier = function getEntryIdentifier(path) {
  if (t.isClass(path)) return getPositionIdentifier(path);
  if (t.isFunction(path)) return getFunctionIdentifier(path);

  throw path.buildCodeFrameError('`path` must be Class or Function definition');
};

exports.default = getEntryIdentifier;